#include <M5Stack.h>
#include <Wire.h>
#include <WiFi.h>
#include <WiFiUDP.h>
#define FACES_KEYBOARD_I2C_ADDR 0x08

static WiFiUDP udp; 
static const int rport = 9000; //送信先のポート
static const int lport = 7000;  //自身のポート
String str="";
String lip="";
String msg="";
int lmsg=7;
int lptr=0;
int rp[]={192,168,0,0};
String rip="";
char ripc[50];
int setM=0;

void drawLcd() {
  M5.Lcd.clear();
  M5.Lcd.setTextSize(2);
  M5.Lcd.setTextColor(TFT_YELLOW,TFT_BLACK);
  M5.Lcd.setCursor(0,0); M5.Lcd.print(" < M5 STACK Controller >");
  M5.Lcd.setCursor(0,20); M5.Lcd.print("My IP:"+lip);
  M5.Lcd.setCursor(0,40); M5.Lcd.print("Setting Mode:"+String(setM));
  rip=String(rp[0])+"."+String(rp[1])+"."+String(rp[2])+"."+String(rp[3]);
  M5.Lcd.setCursor(0,60); M5.Lcd.print("RcvIP:"+rip);
  
  M5.Lcd.setCursor(0,100); M5.Lcd.print(msg);
}

void setup() {
  M5.begin();
  Wire.begin();
  
  M5.Lcd.clear();
  M5.Lcd.setTextSize(2);
  M5.Lcd.setTextColor(TFT_YELLOW,TFT_BLACK);
  M5.Lcd.setCursor(0,0); M5.Lcd.print(" < M5 STACK Controller >");
  M5.Lcd.setCursor(0,40); M5.Lcd.print("Home WiFi  : Press Btn A");
  M5.Lcd.setCursor(0,60); M5.Lcd.print("Mobile WiFi: Press Btn B");
  const char* ssid;
  const char* password;
  while (1){
    if (M5.BtnA.wasPressed()){ // ご自分のWiFiルーター１のSSIDとパスワードに合うように書き換えてください
      lip="192.168.64.xx";
      rp[0]=192; rp[1]=168; rp[2]=64; rp[3]=40;
      ssid = "**********";
      password = "**********";
      M5.Lcd.setCursor(0,100); M5.Lcd.print("Home WiFi was Selected");
      break;
    } else if(M5.BtnB.wasPressed()){ // ご自分のWiFiルーター２のSSIDとパスワードに合うように書き換えてください
      lip="192.168.100.xx";
      rp[0]=192; rp[1]=168; rp[2]=100; rp[3]=100;
      ssid = "**********";
      password = "**********";
      M5.Lcd.setCursor(0,100); M5.Lcd.print("Mobile WiFi was Selected");
      break;
    }
    M5.update();
    delay(100);
  }
  WiFi.mode(WIFI_STA);                    // 無線LANをSTAモードに設定
  WiFi.begin(ssid,password);                  // 無線LANアクセスポイントへ接続
  while(WiFi.status() != WL_CONNECTED){   // 接続に成功するまで待つ
    delay(500);                        // 待ち時間処理
  }  

  lip=WiFi.localIP().toString();
  drawLcd();
  while(1){
    if(M5.BtnA.wasPressed()){
      ++setM; if (setM>4) setM=0;
      drawLcd();
    } else if (M5.BtnB.wasPressed() && setM<4 && rp[setM]>0 ){
      --rp[setM]; drawLcd();
    } else if (M5.BtnC.wasPressed() && setM<4 && rp[setM]<255){
      ++rp[setM]; drawLcd();
    } else if (setM==4 && (M5.BtnB.wasPressed() || M5.BtnC.wasPressed())){
      break;
    }
    M5.update();
    delay(100);
  }
  rip.toCharArray(ripc,50);
  delay(100);
  udp.begin(rport);
  msg="Ready!";
  drawLcd();
}

void loop() {
  Wire.requestFrom(FACES_KEYBOARD_I2C_ADDR, 1);
  int c;
  char chr;
  while (Wire.available()) {
    c = 255-Wire.read(); // receive a byte as character
    if (c ==1 || c==2 || c==4 || c==8 || c==16 || c==32 || c== 64 || c== 128) {
      msg="";
      switch (c){
        case 1: msg="Front"; chr='F'; break;
        case 2: msg="Back"; chr='B'; break;
        case 4: msg="Left"; chr='L'; break;
        case 8: msg="Right"; chr='R'; break;
        case 16: msg="Stop"; chr='S'; break; // ButtonA
        case 32: msg="Stop"; chr='S'; break; // ButtonB
        case 64: msg="Stop"; chr='S'; break; // Select
        case 128: msg="Stop"; chr='S'; break; // Start 
      }
      udp.beginPacket(ripc,rport);  // 送信パケットの開始
      udp.write(chr);                   // 送信メッセージを送信
      udp.endPacket();                    // 送信パケットの終了
      drawLcd();
      delay(2000);
      msg="Stop";
      drawLcd();
    }

  }
}
